pipeline {
    agent any
    parameters {
                string(
                        name: "VM_USER",
                        defaultValue: "ubuntu")
                
                string(
                        name: "VM_IP",
                        defaultValue: "18.188.162.50")
                string(
                        name: "REGISTRY_URL",
                        defaultValue: "registry-itau.mastertech.com.br ")
                string(
                        name: "MYIMAGE",
                        defaultValue: "registry-itau.mastertech.com.br/alan-moreira-api-investimento")
                }
    post{
        failure {
            updateGitlabCommitStatus name: "build", state: "failed"
        }
        success {
            updateGitlabCommitStatus name: "build", state: "success"
        }
        always {
            cleanWs()
        }

    }
    stages {
        stage("Test") {
            steps {
                    sh "./mvnw test"
                    }
            }
        stage("Build"){
            when{branch "master"}
            /*
            Todos os blocos de stage (Package, Build and push image e Deploy serão executados apenas
            quando o evento disparado pelo SCM for na branch master.
            */
            stages{
                stage("Package") {
                    when{branch "master"}
                    steps {
                        script{
                            sh "./mvnw package -DskipTests"
                        }
                    }
                }
                stage("Build and push image"){
                    steps{
                        script {
                            docker.withRegistry("https://${params.REGISTRY_URL}","registry_credential"){
                                def customImage=docker.build("${params.MYIMAGE}")
                                /* Os dois 'push' abaixo fazem o push da imagem para o registry com a tag latest e a tag do numero do build da pipeline */
                                customImage.push("${env.BUILD_ID}")
                                customImage.push("latest")
                            }
                        }
                    }
                }
                stage("Deploy"){
                    steps{
                        /*
                        sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_IP} 'docker pull ${params.MYIMAGE}:latest'"
                        sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_IP} 'docker stop api_invest_alan'"
                        sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_IP} 'docker run --rm -p 5000:8080 -d --name api_invest_alan ${params.MYIMAGE}:latest'"
                        */

                        sh "kubectl apply -f deployment.yaml -n alan-moreira-namespace"
                        sh "kubectl apply -f service.yaml -n alan-moreira-namespace"
                        sh "kubectl apply -f ingress.yaml -n alan-moreira-namespace"
                    }
                }
            }
        }
    }
}